/********************************** (C) COPYRIGHT *******************************
* File Name          :Compound_Dev.C
* Author             : WCH
* Version            : V1.3
* Date               : 2016/1/15
* Description        : CH559ģHID豸ϴADCɼ
*******************************************************************************/
#include "DEBUG.C"                                                       //Ϣӡ
#include "DEBUG.H"
#include <string.h>
#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE
UINT8X  Ep0Buffer[8<(THIS_ENDP0_SIZE+2)?8:(THIS_ENDP0_SIZE+2)] _at_ 0x0000;    //˵0 OUT&INżַ
UINT8X  Ep2Buffer[128<(2*MAX_PACKET_SIZE+4)?128:(2*MAX_PACKET_SIZE+4)] _at_ 0x0010;//˵2 IN&OUT,żַ
UINT8   SetupReq,SetupLen,Ready,Count,FLAG,UsbConfig;
PUINT8  pDescr;                                                                //USBñ־
USB_SETUP_REQ   SetupReqBuf;                                                   //ݴSetup
UINT16 ADC_DATA;

#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
#define DEBUG 0
sbit Ep2InKey = P0^0;                                                          //K3
#pragma  NOAREGS
/*豸*/
UINT8C DevDesc[18] = {0x12,0x01,0x10,0x01,0x00,0x00,0x00,0x08,
                      0x31,0x51,0x07,0x20,0x00,0x00,0x00,0x00,
                      0x00,0x01
                     };
UINT8C CfgDesc[41] =
{
    0x09,0x02,0x29,0x00,0x01,0x01,0x04,0xA0,0x23,             //
    0x09,0x04,0x00,0x00,0x02,0x03,0x00,0x00,0x05,             //ӿ,
    0x09,0x21,0x00,0x01,0x00,0x01,0x22,0x22,0x00,             //HID
    0x07,0x05,0x82,0x03,0x40,0x00,0x18,                       //˵
    0x07,0x05,0x02,0x03,0x40,0x00,0x18,                       //˵
};
/*ַ*/
/*HID౨*/
UINT8C HIDRepDesc[ ] =
{
    0x06, 0x00,0xff,
    0x09, 0x01,
    0xa1, 0x01,                                                 //Ͽʼ
    0x09, 0x02,                                                   //Usage Page  ÷
    0x15, 0x00,                                                 //Logical  Minimun
    0x26, 0x00,0xff,                                              //Logical  Maximun
    0x75, 0x08,                                                   //Report Size
    0x95, 0x40,                                                   //Report Counet
    0x81, 0x06,                                                   //Input
    0x09, 0x02,                                                   //Usage Page  ÷
    0x15, 0x00,                                                   //Logical  Minimun
    0x26, 0x00,0xff,                                              //Logical  Maximun
    0x75, 0x08,                                                   //Report Size
    0x95, 0x40,                                                   //Report Counet
    0x91, 0x06,                                                   //Output
    0xC0
};
// unsigned char  code LangDes[]={0x04,0x03,0x09,0x04};           //
// unsigned char  code SerDes[]={
//                0x28,0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//                0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
//                           0x00,0x00,0x00,0x00,0x00,0x49,0x00,0x43,0x00,0x42,
//                           0x00,0x43,0x00,0x31,0x00,0x00,0x00,0x00,0x00,0x00
//                           };                                               //ַ
UINT8X UserEp2Buf[64] _at_ 0x0090;
/*******************************************************************************
* Function Name  : USBDeviceCfg()
* Description    : USB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceCfg()
{
    USB_CTRL = 0x00;                                                           //USBƼĴ
    USB_CTRL &= ~bUC_HOST_MODE;                                                //λΪѡ豸ģʽ
    USB_CTRL |=  bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;                    //USB豸ڲʹ,жڼжϱ־δǰԶNAK
    USB_DEV_AD = 0x00;                                                         //豸ַʼ
    UDEV_CTRL &= ~bUD_RECV_DIS;                                                //ʹܽ
//     USB_CTRL |= bUC_LOW_SPEED;
//     UDEV_CTRL |= bUD_LOW_SPEED;                                                //ѡ1.5Mģʽ
    USB_CTRL &= ~bUC_LOW_SPEED;
    UDEV_CTRL &= ~bUD_LOW_SPEED;                                             //ѡȫ12MģʽĬϷʽ
    UDEV_CTRL |= bUD_DP_PD_DIS | bUD_DM_PD_DIS;                                //ֹDMDP
    UDEV_CTRL |= bUD_PORT_EN;                                                  //ʹ˿
}
/*******************************************************************************
* Function Name  : USBDeviceIntCfg()
* Description    : USB豸ģʽжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceIntCfg()
{
    USB_INT_EN |= bUIE_SUSPEND;                                               //ʹ豸ж
    USB_INT_EN |= bUIE_TRANSFER;                                              //ʹUSBж
    USB_INT_EN |= bUIE_BUS_RST;                                               //ʹ豸ģʽUSB߸λж
    USB_INT_FG |= 0x1F;                                                       //жϱ־
    IE_USB = 1;                                                               //ʹUSBж
    EA = 1;                                                                   //Ƭж
}
/*******************************************************************************
* Function Name  : USBDeviceEndPointCfg()
* Description    : USB豸ģʽ˵ãģHID豸˶˵0Ŀƴ䣬˵2´
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceEndPointCfg()
{
    UEP2_DMA = Ep2Buffer;                                                      //˵2ݴַ
    UEP2_3_MOD |= bUEP2_TX_EN;                                                 //˵2ʹ
    UEP2_3_MOD |= bUEP2_RX_EN;                                                 //˵2ʹ
    UEP2_3_MOD &= ~bUEP2_BUF_MOD;                                              //˵2շ64ֽڻ
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK;                 //˵2Զתͬ־λIN񷵻NAKOUTACK
    UEP0_DMA = Ep0Buffer;                                                      //˵0ݴַ
    UEP4_1_MOD &= ~(bUEP4_RX_EN | bUEP4_TX_EN);                                //˵064ֽշ
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                                 //OUT񷵻ACKIN񷵻NAK
}
/*******************************************************************************
* Function Name  : enp2BlukIn()
* Description    : USB豸ģʽ˵2ϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void enp2BlukIn(UINT8 len )
{
    memcpy( Ep2Buffer+MAX_PACKET_SIZE, UserEp2Buf, len);        //ϴ
    UEP2_T_LEN = len;                                           //ϴݳ
    UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;                  //ʱϴݲӦACK
}
/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH559USBжϴ
*******************************************************************************/
void    DeviceInterrupt( void ) interrupt INT_NO_USB using 1                      //USBжϷ,ʹüĴ1
{
    UINT8 len,i;
#if DEBUG
    printf("%02X ",(UINT16)USB_INT_FG);
#endif
    if(UIF_TRANSFER)                                                            //USBɱ־
    {
        switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
        {
        case UIS_TOKEN_IN | 2:                                                  //endpoint 2# ˵ϴ
            UEP2_T_LEN = 0;                                                    //Ԥʹ÷ͳһҪ
//            UEP1_CTRL ^= bUEP_T_TOG;                                          //ԶתҪֶת
            UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            break;
        case UIS_TOKEN_OUT | 2:                                                 //endpoint 2# ˵´
//             if ( U_TOG_OK )                                                     // ͬݰ
//             {
//                 len = USB_RX_LEN;                                                 //ݳȣݴEp2Buffer׵ַʼ
//                 for ( i = 0; i < len; i ++ )
//                 {
//                     Ep2Buffer[MAX_PACKET_SIZE+i] = Ep2Buffer[i] ^ 0xFF;           // OUTȡINɼ֤
//                 }
//                 UEP2_T_LEN = len;
//                 UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;         // ϴ
//             }
            break;
        case UIS_TOKEN_SETUP | 0:                                                //SETUP
            len = USB_RX_LEN;
            if(len == (sizeof(USB_SETUP_REQ)))
            {
                SetupLen = UsbSetupBuf->wLengthL;
                if(UsbSetupBuf->wLengthH || SetupLen > 0x7F )
                {
                    SetupLen = 0x7F;    // ܳ
                }
                len = 0;                                                      // ĬΪɹϴ0
                if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )/* ֱֻ֧׼ */
                {
                   switch( SetupReq ) 
									{
										case 0x01://GetReport
											break;
										case 0x02://GetIdle
											break;	
										case 0x03://GetProtocol
											break;				
										case 0x09://SetReport										
											break;
										case 0x0A://SetIdle
											break;	
										case 0x0B://SetProtocol
											break;
										default:
											len = 0xFF;  								   /*֧*/					
											break;
									}	
                }
                else
                {
                    //׼
                    SetupReq = UsbSetupBuf->bRequest;
#if DEBUG
                    printf("REQ %02X ",(UINT16)SetupReq);
#endif
                    switch(SetupReq)                                                  //
                    {
                    case USB_GET_DESCRIPTOR:
                        switch(UsbSetupBuf->wValueH)
                        {
                        case 1:                                                       //豸
                            pDescr = DevDesc;                                         //豸͵Ҫ͵Ļ
                            len = sizeof(DevDesc);
                            break;
                        case 2:                                                        //
                            pDescr = CfgDesc;                                          //豸͵Ҫ͵Ļ
                            len = sizeof(CfgDesc);
                            break;
                        case 0x22:                                                     //
#if DEBUG
                            printf("RREQ %02X ",(UINT16)SetupReq);
#endif
                            pDescr = HIDRepDesc;                                       //׼ϴ
                            len = sizeof(HIDRepDesc);
                            Ready = 1;                                                 //иӿڣñ׼λӦһӿɺЧ
                            break;
                        default:
                            len = 0xff;                                                //ֵ֧߳
                            break;
                        }
                        if ( SetupLen > len )
                        {
                            SetupLen = len;    //ܳ
                        }
                        len = SetupLen >= 8 ? 8 : SetupLen;                            //δ䳤
                        memcpy(Ep0Buffer,pDescr,len);                                  //ϴ
                        SetupLen -= len;
                        pDescr += len;
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL;                              //ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if ( SetupLen >= 1 )
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
                        break;
                    case 0x0A:
                        break;
                    case USB_CLEAR_FEATURE:                                            //Clear Feature
                        if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )// ˵
                        {
                            switch( UsbSetupBuf->wIndexL )
                            {
                            case 0x82:
                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x81:
                                UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                break;
                            case 0x02:
                                UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                break;
                            default:
                                len = 0xFF;                                         // ֵ֧Ķ˵
                                break;
                            }
                        }
                        else
                        {
                            len = 0xFF;                                                // Ƕ˵㲻֧
                        }
                        break;
                    case USB_SET_FEATURE:                                          /* Set Feature */
                        if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x00 )                  /* 豸 */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x01 )
                            {
                                if( CfgDesc[ 7 ] & 0x20 )
                                {
                                    /* ûʹܱ־ */
                                }
                                else
                                {
                                    len = 0xFF;                                        /* ʧ */
                                }
                            }
                            else
                            {
                                len = 0xFF;                                            /* ʧ */
                            }
                        }
                        else if( ( UsbSetupBuf->bRequestType & 0x1F ) == 0x02 )             /* ö˵ */
                        {
                            if( ( ( ( UINT16 )UsbSetupBuf->wValueH << 8 ) | UsbSetupBuf->wValueL ) == 0x00 )
                            {
                                switch( ( ( UINT16 )UsbSetupBuf->wIndexH << 8 ) | UsbSetupBuf->wIndexL )
                                {
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵2 IN STALL */
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL;/* ö˵2 OUT Stall */
                                    break;
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵1 IN STALL */
                                    break;
                                default:
                                    len = 0xFF;                                    /* ʧ */
                                    break;
                                }
                            }
                            else
                            {
                                len = 0xFF;                                      /* ʧ */
                            }
                        }
                        else
                        {
                            len = 0xFF;                                          /* ʧ */
                        }
                        break;
                    case USB_GET_STATUS:
                        Ep0Buffer[0] = 0x00;
                        Ep0Buffer[1] = 0x00;
                        if ( SetupLen >= 2 )
                        {
                            len = 2;
                        }
                        else
                        {
                            len = SetupLen;
                        }
                        break;
                    default:
                        len = 0xff;                                                    //ʧ
                        break;
                    }
                }
            }
            else
            {
                len = 0xff;                                                         //ȴ
            }
            if(len == 0xff)
            {
                SetupReq = 0xFF;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
            }
            else if(len <= 8)                                                       //ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1ӦACK
#if DEBUG
                printf("S_U\n");
#endif
            }
            else
            {
                UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1,ӦACK
            }
            break;
        case UIS_TOKEN_IN | 0:                                                      //endpoint0 IN
            switch(SetupReq)
            {
            case USB_GET_DESCRIPTOR:
                len = SetupLen >= 8 ? 8 : SetupLen;                                 //δ䳤
                memcpy( Ep0Buffer, pDescr, len );                                   //ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG;                                             //ͬ־λת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0;                                                      //״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;
        case UIS_TOKEN_OUT | 0:  // endpoint0 OUT
            len = USB_RX_LEN;
            if(SetupReq == 0x09)
            {
                if(Ep0Buffer[0])
                {
                    //printf("Light on Num Lock LED!\n");
                }
                else if(Ep0Buffer[0] == 0)
                {
                    //printf("Light off Num Lock LED!\n");
                }
            }
            UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA0,ӦACK
            break;
        default:
            break;
        }
        UIF_TRANSFER = 0;                                                           //д0ж
    }
    else if(UIF_BUS_RST)                                                                 //豸ģʽUSB߸λж
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                                             //жϱ־
    }
    else if (UIF_SUSPEND)                                                                 //USB߹/
    {
        UIF_SUSPEND = 0;
        if ( USB_MIS_ST & bUMS_SUSPEND )                                             //
        {
#if DEBUG
            printf( "zz" );                                                             //˯״̬
#endif
            while ( XBUS_AUX & bUART0_TX )
            {
                ;    //ȴ
            }
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                                     //USBRXD0źʱɱ
            PCON |= PD;                                                                 //˯
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = 0x00;
        }
    }
    else {                                                                             //ж,ܷ
        USB_INT_FG = 0xFF;                                                             //жϱ־
//      printf("UnknownInt  N");
    }
}

void ADC_Init()
{
	P1_IE=0X00;
	ADC_SETUP|=bADC_POWER_EN;
	ADC_CK_SE=0X02;
	ADC_CTRL &= ~MASK_ADC_CYCLE; 
	ADC_CTRL &= ~(bADC_CHANN_MOD1 | bADC_CHANN_MOD0);
  ADC_EX_SW |= bADC_RESOLUTION;                                              //λ11bit
	mDelayuS(100); 	 
}
void ADC_Change(UINT8 ADC_samlping)
{
	ADC_CHANN=ADC_samlping;
// 	ADC_EX_SW |= bADC_RESOLUTION;
	mDelayuS(10);
	ADC_CTRL|=bADC_SAMPLE;
	mDelayuS(5);
	ADC_CTRL&=~bADC_SAMPLE;	
	while((ADC_STAT & bADC_IF_ACT) == 0);
	ADC_STAT |=bADC_IF_ACT;
	ADC_DATA=ADC_FIFO;
  UserEp2Buf[0] = ADC_DATA>>8;
  UserEp2Buf[1] = ADC_DATA;
}


main()
{
    mDelaymS(30);                                                         //ϵʱ,ȴڲȶ,ؼ
//  CfgFsys( );                                                           //CH559ʱѡ
    mInitSTDIO( );                                                        //0,ڵ
    printf("start ...\n");
   
    ADC_Init();
    ADC_DATA=ADC_FIFO;//ADCʼ֮ȡFIFOЧ
	
    USBDeviceCfg();                                                       //ģ
    USBDeviceEndPointCfg();                                               //˵
    USBDeviceIntCfg();                                                    //жϳʼ
    UEP1_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    UEP2_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ
    FLAG = 0;
    Ready = 0;
    while(1)
    {
        if(Ready && (Ep2InKey==0))
        {
            ADC_Change(1);//ͨ0
	          printf("%02X  ADC_DATA1 %04X  \n",(UINT16)(ADC_STAT&3),(UINT16)ADC_DATA);					
            enp2BlukIn(2);					
//             ADC_Change(2);//ͨ1
// 	          printf("%02X  ADC_DATA1 %04X  \n",(UINT16)(ADC_STAT&3),(UINT16)ADC_DATA);					
//             enp2BlukIn(2);//ϴ2ֽ
//             ADC_Change(4);//ͨ2
// 	          printf("%02X  ADC_DATA1 %04X  \n",(UINT16)(ADC_STAT&3),(UINT16)ADC_DATA);					
//             enp2BlukIn(2);	
//             ADC_Change(8);//ͨ3
// 	          printf("%02X  ADC_DATA1 %04X  \n",(UINT16)(ADC_STAT&3),(UINT16)ADC_DATA);					
//             enp2BlukIn(2);
              mDelaymS(100);
        }
    }
}
